#pragma once

#include "outputCommon.h"

using namespace System;

namespace ruche {
namespace aviutl {
namespace plugins
{
    // t[̐iʒm̂߂̃fQ[gB
    public delegate bool FrameProgressDelegate(int frames, int totalFrames);

    // vr[̍XVv̂߂̃fQ[gB
    public delegate bool UpdatePreviewDelegate();

    // f[^̏o͂ɕKvȏ񋟂C^tF[XB
    public interface class IOutputInfo
    {
        // o͂f[^^CṽtOl擾B
        property OutputFlags OutputTypes
        {
            OutputFlags get();
        }

        // o͂摜̉擾B
        property int OutputImageWidth
        {
            int get();
        }

        // o͂摜̏c擾B
        property int OutputImageHeight
        {
            int get();
        }

        // o͂摜̃t[[g̕ql擾B
        property int OutputImageFrameRateBase
        {
            int get();
        }

        // o͂摜̃t[[g̕l擾B
        property int OutputImageFrameRateScale
        {
            int get();
        }

        // o͂摜̑t[擾B
        property int OutputImageFrameCount
        {
            int get();
        }

        // o͂摜1t[̃oCg擾B
        property int OutputImageFrameSize
        {
            int get();
        }

        // o͂鉹̃TvO[g擾B
        property int OutputAudioSampleRate
        {
            int get();
        }

        // o͂鉹̃`l擾B
        property int OutputAudioChannel
        {
            int get();
        }

        // o͂鉹̑TvO擾B
        property int OutputAudioSampleCount
        {
            int get();
        }

        // o͂鉹1TṽoCg擾B
        property int OutputAudioSampleSize
        {
            int get();
        }

        // o͂t@C̃tpX擾B
        property String^ OutputFilePath
        {
            String^ get();
        }

        // [Uɂďfꂽۂ擾B
        property bool IsOutputAborted
        {
            bool get();
        }

        // w肵t[̉摜f[^擾B
        // f[^͎ɂ̊֐Ăяo܂ŕێB
        // frame : t[ʒuB
        // return:
        //      24rbgBGRgbv_E`̉摜f[^zB
        //      擾łȂꍇ̓[NAꂽzB
        array<Byte>^ GetOutputImage(int frame);

        // w肵Tv͈͂̉f[^擾B
        // f[^͎ɂ̊֐Ăяo܂ŕێB
        // start  : JnTvʒuB
        // length : TvBK̒ɂȂƂ͌ȂB
        // return:
        //      PCMf[^zB
        //      擾łȂꍇ̓[NAꂽzB
        array<Byte>^ GetOutputAudio(int start, int length);

        // w肵t[̃rfIt[tO擾B
        // frame : t[ʒuB
        // return:
        //      rfIt[tOl̘_aB
        OutputVideoFrameFlags GetVideoFrameFlags(int frame);

        // t[̐iʒm̂߂̃fQ[g擾܂͐ݒ肷B
        property FrameProgressDelegate^ FrameProgress
        {
            FrameProgressDelegate^ get();
            void set(FrameProgressDelegate^ value);
        }

        // vr[̍XVv̂߂̃fQ[g擾܂͐ݒ肷B
        property UpdatePreviewDelegate^ UpdatePreview
        {
            UpdatePreviewDelegate^ get();
            void set(UpdatePreviewDelegate^ value);
        }
    };
}
}}
